#include "bits/stdc++.h"

using namespace std;

int main() {
  ios_base::sync_with_stdio(0);

  // Deklarujemy i wczytujemy liczbę zadań.
  int N;
  cin >> N;

  // Deklarujemy wektor na wartości punktowe zadań.
  vector <long long> V(N);
  // Wczytujemy punktację zadań.
  for (int i=0; i<N; i++) cin >> V[i];

  // Sortujemy liczbę punktów od największej do najmniejszej.
  sort(V.begin(), V.end(), greater<long long>());

  // Liczymy sumy prefiksowe.
  // Warto zwrócić uwagę, że wartości tych sum nie mieszczą się
  // w typie int, dlatego używamy long longów.
  vector <long long> sumy(N);
  sumy[0] = V[0];
  for (int i=1; i<N; i++) {
    sumy[i] = sumy[i-1] + V[i];
  }

  // Deklarujemy i wczytujemy liczbę zapytań
  // (potencjalnych progów punktowych).
  int Q;
  cin >> Q;

  // Dla każdego zapytania,
  while (Q--) {
    // deklarujemy i wczytujemy jego wartość
    long long P;
    cin >> P;
    // i wykorzystujemy wyszukiwanie binarne.
    // Ustawiamy początek i koniec przedziału, w którym wyszukujemy,
    int start = 0, koniec = N-1;
    // a następnie póki przedział ten jest niepusty,
    while(start <= koniec) {
      // wybieramy środkowy element z tego przedziału,
      int srodek = (start+koniec)/2;
      // i porównujemy jego wartość z naszym zapytaniem,
      // odpowiednio zmieniając jeden z końców przedziału.
      if (sumy[srodek] < P) start = srodek+1;
      else koniec = srodek-1;
    }
    // Finalnie wypisujemy liczbę zadań, powiększoną o jeden
    // (otrzymujemy wskaźnik na tablicę zadań, numerowaną od 0).
    cout << start+1 << "\n";
  }
}
